-----------------------------------------------------------------------------------------
--- [SR22-JP028] 烈日凌空(172017210) 场地魔法 (Custom)
--- ①：龙族怪兽特殊召唤时发动。那些怪兽攻击力上升1000。
--- ②：1回合1次，自己场上有5星以上的光·暗属性的龙族怪兽存在的场合才能发动。
---    从卡组选1张不持有其他字段的「龙之」魔法·陷阱卡加入手卡。
--- ③：魔法·陷阱卡送去墓地时，以那些卡中的1张和自己场上1张「主宰龙 无穷烈日」为对象才能发动。
---    那只怪兽上2个「燃料指示物」取除。结束阶段，选择的卡在自己场上盖放。
-----------------------------------------------------------------------------------------
local s,id,o=GetID()

s.dragons={
    -- ドラゴンの
	[ 1435851]=1, --秘宝
	[92408984]=1, --宝珠
    -- 竜の
	[28596933]=1, --振翅
	[55991637]=1, --炎弹
	[54178050]=1, --逆鳞
	[ 2833249]=1, --血族
	[62265044]=1, --溪谷
    [20638610]=1, --转生
    [90887783]=1, --交感
    [41620959]=1, --霊廟
    [16278116]=1, --束缚
    [69868555]=1, --遗迹
    [95697223]=1, --斗志
    [50186558]=1, --结界（守护龙）
    [11908584]=1, --核醒（守护龙）
    [63295720]=1, --影光
    -- 龍の
	[71490127]=1, --镜
	[87025064]=1, --轰咆
	[40971261]=1, --旋律
    [43219114]=1, --威光（白龙）
	[11434258]=1, --蛇龙的枷锁
	[92428405]=1, --霸王龙之魂
    [40456412]=1, --霸王龙的奇迹
    [76840111]=1, --霸王天龙之魂
    -- DIY
    --[172017211]=1, --再聚变
    [172017212]=1, --超新星
    [172017213]=1  --息吹
}

function s.initial_effect(c)
	--Activate
	local e0=Effect.CreateEffect(c)
	e0:SetType(EFFECT_TYPE_ACTIVATE)
	e0:SetCode(EVENT_FREE_CHAIN)
	e0:SetHintTiming(0,TIMING_END_PHASE)
	c:RegisterEffect(e0)
    --atk up
    local e1=Effect.CreateEffect(c)
    e1:SetType(EFFECT_TYPE_FIELD+EFFECT_TYPE_TRIGGER_F)
    e1:SetCode(EVENT_SPSUMMON_SUCCESS)
    e1:SetRange(LOCATION_FZONE)
    e1:SetCondition(s.atkcon)
    e1:SetOperation(s.atkop)
    c:RegisterEffect(e1)
    --to hand
	local e2=Effect.CreateEffect(c)
	e2:SetCategory(CATEGORY_TOHAND+CATEGORY_SEARCH)
	e2:SetType(EFFECT_TYPE_IGNITION)
	e2:SetRange(LOCATION_FZONE)
	e2:SetCountLimit(1)
    e2:SetCondition(s.thcon)
	e2:SetTarget(s.thtg)
	e2:SetOperation(s.thop)
	c:RegisterEffect(e2)
    --return
    local e3=Effect.CreateEffect(c)
    e3:SetType(EFFECT_TYPE_FIELD+EFFECT_TYPE_TRIGGER_O)
    e3:SetCode(EVENT_TO_GRAVE)
    e3:SetRange(LOCATION_FZONE)
    e3:SetCondition(s.retcon)
    e3:SetTarget(s.rettg)
    e3:SetOperation(s.retop)
    c:RegisterEffect(e3)
end
function s.thfilter1(c)
    return c:IsRace(RACE_DRAGON) and c:IsAttribute(ATTRIBUTE_LIGHT+ATTRIBUTE_DARK) and c:IsLevelAbove(5)
end
function s.thfilter2(c)
    return s.dragons[c:GetCode()]~=nil
end
function s.atkcon(e,tp,eg,ep,ev,re,r,rp)
	return eg:IsExists(Card.IsRace,1,nil,RACE_DRAGON)
end
function s.atkop(e,tp,eg,ep,ev,re,r,rp)
    local c=e:GetHandler()
    local g=eg:Filter(Card.IsRace,nil,RACE_DRAGON)
	for tc in aux.Next(g) do
		local e1=Effect.CreateEffect(c)
		e1:SetType(EFFECT_TYPE_SINGLE)
		e1:SetCode(EFFECT_UPDATE_ATTACK)
		e1:SetValue(1000)
		e1:SetReset(RESET_EVENT+RESETS_STANDARD)
		tc:RegisterEffect(e1)
	end
end
function s.thcon(e,tp,eg,ep,ev,re,r,rp)
	return Duel.IsExistingMatchingCard(s.thfilter1,tp,LOCATION_MZONE,0,1,nil)
end
function s.thtg(e,tp,eg,ep,ev,re,r,rp,chk)
	if chk==0 then return true end
	Duel.SetOperationInfo(0,CATEGORY_TOHAND,nil,1,tp,LOCATION_DECK)
end
function s.thop(e,tp,eg,ep,ev,re,r,rp)
	Duel.Hint(HINT_SELECTMSG,tp,HINTMSG_ATOHAND)
	local g=Duel.SelectMatchingCard(tp,s.thfilter2,tp,LOCATION_DECK,0,1,1,nil)
	if g:GetCount()>0 then
		Duel.SendtoHand(g,nil,REASON_EFFECT)
		Duel.ConfirmCards(1-tp,g)
	end
end

function s.retfilter(c,tp)
    return c:IsCode(172017200) and c:IsCanRemoveCounter(tp,0x10ec,2,REASON_EFFECT)
end
function s.retcon(e,tp,eg,ep,ev,re,r,rp)
	return Duel.IsExistingMatchingCard(s.retfilter,tp,LOCATION_MZONE,0,1,nil,tp)
end
function s.rettg(e,tp,eg,ep,ev,re,r,rp,chk)
	if chk==0 then return eg:IsExists(Card.IsType,1,nil,TYPE_SPELL+TYPE_TRAP) end
	Duel.Hint(HINT_SELECTMSG,tp,HINTMSG_RTOHAND)
    local g1=eg:Filter(Card.IsType,nil,TYPE_SPELL+TYPE_TRAP):Select(tp,1,1,nil)
    local g2=Duel.SelectMatchingCard(tp,s.retfilter,tp,LOCATION_MZONE,0,1,1,nil,tp)
    g1:Merge(g2)
    Duel.SetTargetCard(g1)
	Duel.SetOperationInfo(0,CATEGORY_TOHAND,nil,1,tp,LOCATION_GRAVE)
end
function s.retop(e,tp,eg,ep,ev,re,r,rp)
    local g=Duel.GetChainInfo(0,CHAININFO_TARGET_CARDS)
    local retc=g:GetFirst()
    local counterc=g:GetNext()
    if counterc:IsCanRemoveCounter(tp,0x10ec,2,REASON_EFFECT) then
        counterc:RemoveCounter(tp,0x10ec,2,REASON_EFFECT)
        local e1=Effect.CreateEffect(e:GetHandler())
        e1:SetType(EFFECT_TYPE_FIELD+EFFECT_TYPE_CONTINUOUS)
        e1:SetCode(EVENT_PHASE+PHASE_END)
        e1:SetCountLimit(1)
        e1:SetLabelObject(retc)
        e1:SetCondition(s.retcon)
        e1:SetOperation(s.retop2)
        e1:SetReset(RESET_PHASE+PHASE_DRAW)
        Duel.RegisterEffect(e1,tp)
    end
end

function s.retop2(e,tp,eg,ep,ev,re,r,rp)
    local tc=e:GetLabelObject()
    if tc:GetLocation()==LOCATION_GRAVE then
        Duel.SSet(tp,tc)
    end
end
